# coding: utf-8

"""
    Weheat Backend

    This is the backend for the Weheat project

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class HeatPumpLogViewDto(BaseModel):
    """
    HeatPumpLogViewDto
    """
    time_bucket: Optional[datetime] = Field(None, alias="timeBucket", description="Timestamp of the beginning of this interval (UTC)")
    interval: Optional[StrictStr] = Field(None, description="Interval Granularity of this HeatPumpLogViewDto (Correct intervals include: \"Hour\", \"Day\", \"Week\", \"Month\", \"Year\")")
    time_covered_in_interval: Optional[StrictInt] = Field(None, alias="timeCoveredInInterval", description="Amount of time covered by this interval in seconds out of a maximum of the Interval (Granularity) in seconds")
    heat_pump_state_standby: Optional[StrictInt] = Field(None, alias="heatPumpStateStandby", description="Amount of seconds the heat pump spend in the standby state for this interval")
    heat_pump_state_heating: Optional[StrictInt] = Field(None, alias="heatPumpStateHeating", description="Amount of seconds the heat pump spend in the heating state for this interval")
    heat_pump_state_defrost_req_active: Optional[StrictInt] = Field(None, alias="heatPumpStateDefrostReqActive", description="Amount of seconds the heat pump spend in the defrost required active state for this interval")
    heat_pump_state_defrost_open_valve: Optional[StrictInt] = Field(None, alias="heatPumpStateDefrostOpenValve", description="Amount of seconds the heat pump spend in the defrost opening valve state for this interval")
    heat_pump_state_defrost_close_valve: Optional[StrictInt] = Field(None, alias="heatPumpStateDefrostCloseValve", description="Amount of seconds the heat pump spend in the defrost state closing valve for this interval")
    heat_pump_state_defrost_drip: Optional[StrictInt] = Field(None, alias="heatPumpStateDefrostDrip", description="Amount of seconds the heat pump spend in the defrost drip state for this interval")
    heat_pump_state_defrost_cooling: Optional[StrictInt] = Field(None, alias="heatPumpStateDefrostCooling", description="Amount of seconds the heat pump spend in the defrost cooling state for this interval")
    heat_pump_state_cooling: Optional[StrictInt] = Field(None, alias="heatPumpStateCooling", description="Amount of seconds the heat pump spend in the cooling state for this interval")
    heat_pump_state_dhw: Optional[StrictInt] = Field(None, alias="heatPumpStateDHW", description="Amount of seconds the heat pump spend in the (heating) Domestic Hot Water stae for this interval")
    heat_pump_state_legionnaires_disease_prevention: Optional[StrictInt] = Field(None, alias="heatPumpStateLegionnairesDiseasePrevention", description="Amount of seconds the heat pump spend in the Legionnaires' Disease Prevention state for this interval")
    rpm_control_startup: Optional[StrictInt] = Field(None, alias="rpmControlStartup", description="Amount of seconds the heat pump spend in one of the RPM Control Startup states for this interval")
    rpm_control_running: Optional[StrictInt] = Field(None, alias="rpmControlRunning", description="Amount of seconds the heat pump spend in one of the RPM Control Running state for this interval")
    rpm_control_running_abnormally: Optional[StrictInt] = Field(None, alias="rpmControlRunningAbnormally", description="Amount of seconds the heat pump spend in the RPM Control Running Abnormally states for this interval")
    rpm_control_shutdown: Optional[StrictInt] = Field(None, alias="rpmControlShutdown", description="Amount of seconds the heat pump spend in one of the RPM Control Shutdown states for this interval")
    control_bridge_status_water_pump: Optional[StrictInt] = Field(None, alias="controlBridgeStatusWaterPump", description="Amount of seconds the heat pump spend in the Control Bridge Status Water Pump state to true for this interval")
    control_bridge_status_dhw_valve: Optional[StrictInt] = Field(None, alias="controlBridgeStatusDhwValve", description="Amount of seconds the heat pump spend in the Control Bridge Status DHW Valve state to true for this interval")
    control_bridge_status_gas_boiler: Optional[StrictInt] = Field(None, alias="controlBridgeStatusGasBoiler", description="Amount of seconds the heat pump spend in the Control Bridge Status Gas Boiler state to true for this interval")
    control_bridge_status_electric_heater: Optional[StrictInt] = Field(None, alias="controlBridgeStatusElectricHeater", description="Amount of seconds the heat pump spend in the Control Bridge Status Electric Heater state to true for this interval")
    control_bridge_status_water_pump2: Optional[StrictInt] = Field(None, alias="controlBridgeStatusWaterPump2", description="Amount of seconds the heat pump spend in the Control Bridge Status Water Pump 2 state to true for this interval")
    dtc_none: Optional[StrictInt] = Field(None, alias="dtcNone", description="Amount of seconds the heat pump spend in the No DTC codes Error state for this interval (staff only)")
    dtc_continue: Optional[StrictInt] = Field(None, alias="dtcContinue", description="Amount of seconds the heat pump spend in the DTC but can Continue Error state for this interval (staff only)")
    dtc_compressor_off: Optional[StrictInt] = Field(None, alias="dtcCompressorOff", description="Amount of seconds the heat pump spend in the DTC Compressor Off Error state for this interval (staff only)")
    dtc_defrost_forbidden: Optional[StrictInt] = Field(None, alias="dtcDefrostForbidden", description="Amount of seconds the heat pump spend in the DTC Defrost Forbidden Error state for this interval (staff only)")
    dtc_request_service: Optional[StrictInt] = Field(None, alias="dtcRequestService", description="Amount of seconds the heat pump spend in the DTC Request Service Error state for this interval (staff only)")
    dtc_use_heating_curve: Optional[StrictInt] = Field(None, alias="dtcUseHeatingCurve", description="Amount of seconds the heat pump spend in the DTC Use Heating Curve (only) Error state for this interval (staff only)")
    dtc_dhw_forbidden: Optional[StrictInt] = Field(None, alias="dtcDhwForbidden", description="Amount of seconds the heat pump spend in the DTC HW Forbidden Error state for this interval (staff only)")
    dtc_error: Optional[StrictInt] = Field(None, alias="dtcError", description="Amount of seconds the heat pump spend in the DTC DTC Error state for this interval (staff only)")
    dtc_inactive: Optional[StrictInt] = Field(None, alias="dtcInactive", description="Amount of seconds the heat pump spend in the DTC Inactive Error state for this interval (staff only)")
    signal_strength_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="signalStrengthAverage", description="Average of the Signal Strength (integer out of 20) of the heat pump for this interval (staff only)")
    signal_strength_min: Optional[StrictInt] = Field(None, alias="signalStrengthMin", description="Minimal Signal Strength (integer out of 20) of the heat pump for this interval (staff only)")
    signal_strength_max: Optional[StrictInt] = Field(None, alias="signalStrengthMax", description="Maximum Signal Strength (integer out of 20) of the heat pump for this interval (staff only)")
    t1_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="t1Average", description="Average temperature of the top DHW sensor (T1) of the heat pump for this interval")
    t1_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="t1Min", description="Minimum temperature of the top DHW sensor (T1) of the heat pump for this interval")
    t1_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="t1Max", description="Maximum temperature of the top DHW sensor (T1) of the heat pump for this interval")
    t2_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="t2Average", description="Average temperature of the bottom DHW sensor (T2) of the heat pump for this interval")
    t2_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="t2Min", description="Minimum temperature of the bottom DHW sensor (T2) of the heat pump for this interval")
    t2_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="t2Max", description="Maximum temperature of the bottom DHW sensor (T2) of the heat pump for this interval")
    t_spare_ntc_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tSpareNtcAverage", description="Average temperature of the spare DHW sensor (TSpareNTC) of the heat pump for this interval (staff only)")
    t_spare_ntc_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tSpareNtcMin", description="Minimum temperature of the spare DHW sensor (TSpareNTC) of the heat pump for this interval (staff only)")
    t_spare_ntc_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tSpareNtcMax", description="Maximum temperature of the spare DHW sensor (TSpareNTC) of the heat pump for this interval (staff only)")
    t_board_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tBoardAverage", description="Average temperature of the control board of the heat pump for this interval (staff only)")
    t_board_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tBoardMin", description="Minimum temperature of the control board of the heat pump for this interval (staff only)")
    t_board_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tBoardMax", description="Maximum temperature of the control board of the heat pump for this interval (staff only)")
    t_air_in_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tAirInAverage", description="Average temperature of air going into the heat pump for this interval")
    t_air_in_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tAirInMin")
    t_air_in_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tAirInMax")
    t_air_out_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tAirOutAverage", description="Average temperature of air going out of the heat pump for this interval")
    t_air_out_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tAirOutMin", description="Minimum temperature of air going out of the heat pump for this interval")
    t_air_out_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tAirOutMax", description="Maximum temperature of air going out of the heat pump for this interval")
    t_water_in_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterInAverage", description="Average temperature of the water going into the heat pump for this interval")
    t_water_in_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterInMin", description="Minimum temperature of the water going into the heat pump for this interval")
    t_water_in_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterInMax", description="Maximum temperature of the water going into the heat pump for this interval")
    t_water_out_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterOutAverage", description="Average temperature of the water going out of the heat pump for this interval")
    t_water_out_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterOutMin", description="Minimum temperature of the water going out of the heat pump for this interval")
    t_water_out_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterOutMax", description="Maximum temperature of the water going out of the heat pump for this interval")
    t_water_house_in_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterHouseInAverage", description="Average temperature of the water going into the house for this interval")
    t_water_house_in_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterHouseInMin", description="Minimum temperature of the water going into the house for this interval")
    t_water_house_in_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tWaterHouseInMax", description="Maximum temperature of the water going into the house for this interval")
    rpm_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="rpmAverage", description="Average RPM of the compressor for this interval (not for consumers)")
    rpm_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="rpmMin", description="Minimum RPM of the compressor for this interval (not for consumers)")
    rpm_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="rpmMax", description="Maximum RPM of the compressor for this interval (not for consumers)")
    rpm_limiter_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="rpmLimiterAverage", description="Average RPM value the heat pump was limited to for this interval (staff only)")
    rpm_limiter_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="rpmLimiterMin", description="Minimum RPM value the heat pump was limited to for this interval (staff only)")
    rpm_limiter_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="rpmLimiterMax", description="Maximum RPM value the heat pump was limited to for this interval (staff only)")
    rpm_limiter_no_limit: Optional[StrictInt] = Field(None, alias="rpmLimiterNoLimit", description="Amount of time the compressor RPM was not Limited at all by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_power_limit: Optional[StrictInt] = Field(None, alias="rpmLimiterPowerLimit", description="Amount of time the compressor RPM was being most limited by the amount of Power by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_defrost: Optional[StrictInt] = Field(None, alias="rpmLimiterDefrost", description="Amount of time the compressor RPM was being most limited because of Defrost by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_silent_hours: Optional[StrictInt] = Field(None, alias="rpmLimiterSilentHours", description="Amount of time the compressor RPM was being most limited because of Silent Hours by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_hp_control: Optional[StrictInt] = Field(None, alias="rpmLimiterHPControl", description="Amount of time the compressor RPM was being most limited because of HP Control method by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_pressure: Optional[StrictInt] = Field(None, alias="rpmLimiterPressure", description="Amount of time the compressor RPM was being most limited because of its Pressure by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_water_out: Optional[StrictInt] = Field(None, alias="rpmLimiterWaterOut", description="Amount of time the compressor RPM was being most limited because of its Water Out temperature by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_envelope: Optional[StrictInt] = Field(None, alias="rpmLimiterEnvelope", description="Amount of time the compressor RPM was being most limited because of Envelope control method by the RPM Limiter state for this interval (staff only)")
    rpm_limiter_house_in: Optional[StrictInt] = Field(None, alias="rpmLimiterHouseIn", description="Amount of time the compressor RPM was being most limited because of its Water In temperature by the RPM Limiter state for this interval (staff only)")
    p_compressor_in_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorInAverage", description="Average pressure on the intake side of the compressor for this interval (not for consumers)")
    p_compressor_in_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorInMin", description="Minimum pressure on the intake side of the compressor for this interval (not for consumers)")
    p_compressor_in_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorInMax", description="Maximum pressure on the intake side of the compressor for this interval (not for consumers)")
    p_compressor_out_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorOutAverage", description="Average pressure on the output side of the compressor for this interval (not for consumers)")
    p_compressor_out_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorOutMin", description="Minimum pressure on the output side of the compressor for this interval (not for consumers)")
    p_compressor_out_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorOutMax", description="Maximum pressure on the output side of the compressor for this interval (not for consumers)")
    p_compressor_in_target_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorInTargetAverage", description="Average target pressure (on the intake side) of the compressor for this interval (not for consumers)")
    p_compressor_in_target_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorInTargetMin", description="Minimum target pressure (on the intake side) of the compressor for this interval (not for consumers)")
    p_compressor_in_target_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pCompressorInTargetMax", description="Maximum target pressure (on the intake side) of the compressor for this interval (not for consumers)")
    t_inverter_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tInverterAverage", description="Average temperature of the inverter for this interval (staff only)")
    t_inverter_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tInverterMin", description="Minimum temperature of the inverter for this interval (staff only)")
    t_inverter_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tInverterMax", description="Maximum temperature of the inverter for this interval (staff only)")
    t_compressor_in_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorInAverage", description="Average temperature of intake side of the compressor for this interval (not for consumers)")
    t_compressor_in_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorInMin", description="Minimum temperature of intake side of the compressor for this interval (not for consumers)")
    t_compressor_in_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorInMax", description="Maximum temperature of intake side of the compressor for this interval (not for consumers)")
    t_compressor_out_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorOutAverage", description="Average temperature of output side of the compressor for this interval (not for consumers)")
    t_compressor_out_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorOutMin", description="Minimum temperature of output side of the compressor for this interval (not for consumers)")
    t_compressor_out_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorOutMax", description="Maximum temperature of output side of the compressor for this interval (not for consumers)")
    t_compressor_in_transient_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorInTransientAverage", description="Average temperature transient for the intake side of the compressor for this interval (staff only)")
    t_compressor_in_transient_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorInTransientMin", description="Minimum temperature transient for the intake side of the compressor for this interval (staff only)")
    t_compressor_in_transient_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorInTransientMax", description="Maximum temperature transient for the intake side of the compressor for this interval (staff only)")
    t_compressor_out_transient_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorOutTransientAverage", description="Average temperature transient for the output side of the compressor for this interval (staff only)")
    t_compressor_out_transient_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorOutTransientMin", description="Minimum temperature transient for the output side of the compressor for this interval (staff only)")
    t_compressor_out_transient_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tCompressorOutTransientMax", description="Maximum temperature transient for the output side of the compressor for this interval (staff only)")
    delta_t_compressor_in_superheat_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="deltaTCompressorInSuperheatAverage", description="Average temperature difference in the compressor for Superheat for this interval (staff only)")
    delta_t_compressor_in_superheat_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="deltaTCompressorInSuperheatMin", description="Minimum temperature difference in the compressor for Superheat for this interval (staff only)")
    delta_t_compressor_in_superheat_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="deltaTCompressorInSuperheatMax", description="Maximum temperature difference in the compressor for Superheat for this interval (staff only)")
    compressor_power_low_accuracy_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="compressorPowerLowAccuracyAverage", description="Average power used by the compressor (low accuracy) for this interval (staff only)")
    compressor_power_low_accuracy_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="compressorPowerLowAccuracyMin", description="Minimum power used by the compressor (low accuracy) for this interval (staff only)")
    compressor_power_low_accuracy_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="compressorPowerLowAccuracyMax", description="Maximum power used by the compressor (low accuracy) for this interval (staff only)")
    fan_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="fanAverage", description="Average percentage of the fan used for this interval (staff only)")
    fan_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="fanMin", description="Minimum percentage of the fan used for this interval (staff only)")
    fan_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="fanMax", description="Maximum percentage of the fan used for this interval (staff only)")
    fan_power_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="fanPowerAverage", description="Average power used by the fan for this interval (staff only)")
    fan_power_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="fanPowerMin", description="Minimum power used by the fan for this interval (staff only)")
    fan_power_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="fanPowerMax", description="Maximum power used by the fan for this interval (staff only)")
    cm_mass_power_in_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="cmMassPowerInAverage", description="Average of the total amount of energy produced by the heat pump for this interval (staff only)")
    cm_mass_power_out_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="cmMassPowerOutAverage", description="Average of the total amount of energy produced by the heat pump for this interval (staff only)")
    p_requested_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pRequestedAverage", description="Average Power requested by the heat pump for this interval (staff only)")
    p_requested_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pRequestedMin", description="Minimum Power requested by the heat pump for this interval (staff only)")
    p_requested_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="pRequestedMax", description="Maximum Power requested by the heat pump for this interval (staff only)")
    power_error_integral_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="powerErrorIntegralAverage", description="Average value of the PowerErrorIntegral for this interval (staff only)")
    power_error_integral_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="powerErrorIntegralMin", description="Minimum value of the PowerErrorIntegral for this interval (staff only)")
    power_error_integral_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="powerErrorIntegralMax", description="Maximum value of the PowerErrorIntegral for this interval (staff only)")
    thermostat_state_off: Optional[StrictInt] = Field(None, alias="thermostatStateOff", description="Amount of seconds the heat pump spend in the Thermostat State Off state for this interval")
    thermostat_state_on: Optional[StrictInt] = Field(None, alias="thermostatStateOn", description="Amount of seconds the heat pump spend in the Thermostat State On state for this interval")
    t_room_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tRoomAverage", description="Average temperature of the room for this interval")
    t_room_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tRoomMin", description="Minimum temperature of the room for this interval")
    t_room_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tRoomMax", description="Maximum temperature of the room for this interval")
    t_room_target_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tRoomTargetAverage", description="Average target room temperature of the thermostat for this interval")
    t_room_target_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tRoomTargetMin", description="Minimum target room temperature of the thermostat for this interval")
    t_room_target_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tRoomTargetMax", description="Maximum target room temperature of the thermostat for this interval")
    t_thermostat_setpoint_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tThermostatSetpointAverage", description="Average temperature setpoint of the thermostat for this interval OR the water setpoint of the heat pump")
    t_thermostat_setpoint_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tThermostatSetpointMin", description="Minimum temperature setpoint of the thermostat for this interval OR the water setpoint of the heat pump")
    t_thermostat_setpoint_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="tThermostatSetpointMax", description="Maximum temperature setpoint of the thermostat for this interval OR the water setpoint of the heat pump")
    ot_boiler_feed_temperature_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="otBoilerFeedTemperatureAverage", description="Average OpenTherm boiler water feed temperature for this interval")
    ot_boiler_feed_temperature_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="otBoilerFeedTemperatureMin", description="Minimum OpenTherm boiler water feed temperature for this interval")
    ot_boiler_feed_temperature_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="otBoilerFeedTemperatureMax", description="Maximum OpenTherm boiler water feed temperature for this interval")
    ot_boiler_return_temperature_average: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="otBoilerReturnTemperatureAverage", description="Average OpenTherm boiler water return temperature for this interval")
    ot_boiler_return_temperature_min: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="otBoilerReturnTemperatureMin", description="Minimum OpenTherm boiler water return temperature for this interval")
    ot_boiler_return_temperature_max: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="otBoilerReturnTemperatureMax", description="Maximum OpenTherm boiler water return temperature for this interval")
    __properties = ["timeBucket", "interval", "timeCoveredInInterval", "heatPumpStateStandby", "heatPumpStateHeating", "heatPumpStateDefrostReqActive", "heatPumpStateDefrostOpenValve", "heatPumpStateDefrostCloseValve", "heatPumpStateDefrostDrip", "heatPumpStateDefrostCooling", "heatPumpStateCooling", "heatPumpStateDHW", "heatPumpStateLegionnairesDiseasePrevention", "rpmControlStartup", "rpmControlRunning", "rpmControlRunningAbnormally", "rpmControlShutdown", "controlBridgeStatusWaterPump", "controlBridgeStatusDhwValve", "controlBridgeStatusGasBoiler", "controlBridgeStatusElectricHeater", "controlBridgeStatusWaterPump2", "dtcNone", "dtcContinue", "dtcCompressorOff", "dtcDefrostForbidden", "dtcRequestService", "dtcUseHeatingCurve", "dtcDhwForbidden", "dtcError", "dtcInactive", "signalStrengthAverage", "signalStrengthMin", "signalStrengthMax", "t1Average", "t1Min", "t1Max", "t2Average", "t2Min", "t2Max", "tSpareNtcAverage", "tSpareNtcMin", "tSpareNtcMax", "tBoardAverage", "tBoardMin", "tBoardMax", "tAirInAverage", "tAirInMin", "tAirInMax", "tAirOutAverage", "tAirOutMin", "tAirOutMax", "tWaterInAverage", "tWaterInMin", "tWaterInMax", "tWaterOutAverage", "tWaterOutMin", "tWaterOutMax", "tWaterHouseInAverage", "tWaterHouseInMin", "tWaterHouseInMax", "rpmAverage", "rpmMin", "rpmMax", "rpmLimiterAverage", "rpmLimiterMin", "rpmLimiterMax", "rpmLimiterNoLimit", "rpmLimiterPowerLimit", "rpmLimiterDefrost", "rpmLimiterSilentHours", "rpmLimiterHPControl", "rpmLimiterPressure", "rpmLimiterWaterOut", "rpmLimiterEnvelope", "rpmLimiterHouseIn", "pCompressorInAverage", "pCompressorInMin", "pCompressorInMax", "pCompressorOutAverage", "pCompressorOutMin", "pCompressorOutMax", "pCompressorInTargetAverage", "pCompressorInTargetMin", "pCompressorInTargetMax", "tInverterAverage", "tInverterMin", "tInverterMax", "tCompressorInAverage", "tCompressorInMin", "tCompressorInMax", "tCompressorOutAverage", "tCompressorOutMin", "tCompressorOutMax", "tCompressorInTransientAverage", "tCompressorInTransientMin", "tCompressorInTransientMax", "tCompressorOutTransientAverage", "tCompressorOutTransientMin", "tCompressorOutTransientMax", "deltaTCompressorInSuperheatAverage", "deltaTCompressorInSuperheatMin", "deltaTCompressorInSuperheatMax", "compressorPowerLowAccuracyAverage", "compressorPowerLowAccuracyMin", "compressorPowerLowAccuracyMax", "fanAverage", "fanMin", "fanMax", "fanPowerAverage", "fanPowerMin", "fanPowerMax", "cmMassPowerInAverage", "cmMassPowerOutAverage", "pRequestedAverage", "pRequestedMin", "pRequestedMax", "powerErrorIntegralAverage", "powerErrorIntegralMin", "powerErrorIntegralMax", "thermostatStateOff", "thermostatStateOn", "tRoomAverage", "tRoomMin", "tRoomMax", "tRoomTargetAverage", "tRoomTargetMin", "tRoomTargetMax", "tThermostatSetpointAverage", "tThermostatSetpointMin", "tThermostatSetpointMax", "otBoilerFeedTemperatureAverage", "otBoilerFeedTemperatureMin", "otBoilerFeedTemperatureMax", "otBoilerReturnTemperatureAverage", "otBoilerReturnTemperatureMin", "otBoilerReturnTemperatureMax"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> HeatPumpLogViewDto:
        """Create an instance of HeatPumpLogViewDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if interval (nullable) is None
        # and __fields_set__ contains the field
        if self.interval is None and "interval" in self.__fields_set__:
            _dict['interval'] = None

        # set to None if control_bridge_status_dhw_valve (nullable) is None
        # and __fields_set__ contains the field
        if self.control_bridge_status_dhw_valve is None and "control_bridge_status_dhw_valve" in self.__fields_set__:
            _dict['controlBridgeStatusDhwValve'] = None

        # set to None if dtc_none (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_none is None and "dtc_none" in self.__fields_set__:
            _dict['dtcNone'] = None

        # set to None if dtc_continue (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_continue is None and "dtc_continue" in self.__fields_set__:
            _dict['dtcContinue'] = None

        # set to None if dtc_compressor_off (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_compressor_off is None and "dtc_compressor_off" in self.__fields_set__:
            _dict['dtcCompressorOff'] = None

        # set to None if dtc_defrost_forbidden (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_defrost_forbidden is None and "dtc_defrost_forbidden" in self.__fields_set__:
            _dict['dtcDefrostForbidden'] = None

        # set to None if dtc_request_service (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_request_service is None and "dtc_request_service" in self.__fields_set__:
            _dict['dtcRequestService'] = None

        # set to None if dtc_use_heating_curve (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_use_heating_curve is None and "dtc_use_heating_curve" in self.__fields_set__:
            _dict['dtcUseHeatingCurve'] = None

        # set to None if dtc_dhw_forbidden (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_dhw_forbidden is None and "dtc_dhw_forbidden" in self.__fields_set__:
            _dict['dtcDhwForbidden'] = None

        # set to None if dtc_error (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_error is None and "dtc_error" in self.__fields_set__:
            _dict['dtcError'] = None

        # set to None if dtc_inactive (nullable) is None
        # and __fields_set__ contains the field
        if self.dtc_inactive is None and "dtc_inactive" in self.__fields_set__:
            _dict['dtcInactive'] = None

        # set to None if signal_strength_average (nullable) is None
        # and __fields_set__ contains the field
        if self.signal_strength_average is None and "signal_strength_average" in self.__fields_set__:
            _dict['signalStrengthAverage'] = None

        # set to None if signal_strength_min (nullable) is None
        # and __fields_set__ contains the field
        if self.signal_strength_min is None and "signal_strength_min" in self.__fields_set__:
            _dict['signalStrengthMin'] = None

        # set to None if signal_strength_max (nullable) is None
        # and __fields_set__ contains the field
        if self.signal_strength_max is None and "signal_strength_max" in self.__fields_set__:
            _dict['signalStrengthMax'] = None

        # set to None if t1_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t1_average is None and "t1_average" in self.__fields_set__:
            _dict['t1Average'] = None

        # set to None if t1_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t1_min is None and "t1_min" in self.__fields_set__:
            _dict['t1Min'] = None

        # set to None if t1_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t1_max is None and "t1_max" in self.__fields_set__:
            _dict['t1Max'] = None

        # set to None if t2_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t2_average is None and "t2_average" in self.__fields_set__:
            _dict['t2Average'] = None

        # set to None if t2_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t2_min is None and "t2_min" in self.__fields_set__:
            _dict['t2Min'] = None

        # set to None if t2_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t2_max is None and "t2_max" in self.__fields_set__:
            _dict['t2Max'] = None

        # set to None if t_spare_ntc_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t_spare_ntc_average is None and "t_spare_ntc_average" in self.__fields_set__:
            _dict['tSpareNtcAverage'] = None

        # set to None if t_spare_ntc_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t_spare_ntc_min is None and "t_spare_ntc_min" in self.__fields_set__:
            _dict['tSpareNtcMin'] = None

        # set to None if t_spare_ntc_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t_spare_ntc_max is None and "t_spare_ntc_max" in self.__fields_set__:
            _dict['tSpareNtcMax'] = None

        # set to None if t_board_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t_board_average is None and "t_board_average" in self.__fields_set__:
            _dict['tBoardAverage'] = None

        # set to None if t_board_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t_board_min is None and "t_board_min" in self.__fields_set__:
            _dict['tBoardMin'] = None

        # set to None if t_board_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t_board_max is None and "t_board_max" in self.__fields_set__:
            _dict['tBoardMax'] = None

        # set to None if rpm_average (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_average is None and "rpm_average" in self.__fields_set__:
            _dict['rpmAverage'] = None

        # set to None if rpm_min (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_min is None and "rpm_min" in self.__fields_set__:
            _dict['rpmMin'] = None

        # set to None if rpm_max (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_max is None and "rpm_max" in self.__fields_set__:
            _dict['rpmMax'] = None

        # set to None if rpm_limiter_average (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_average is None and "rpm_limiter_average" in self.__fields_set__:
            _dict['rpmLimiterAverage'] = None

        # set to None if rpm_limiter_min (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_min is None and "rpm_limiter_min" in self.__fields_set__:
            _dict['rpmLimiterMin'] = None

        # set to None if rpm_limiter_max (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_max is None and "rpm_limiter_max" in self.__fields_set__:
            _dict['rpmLimiterMax'] = None

        # set to None if rpm_limiter_no_limit (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_no_limit is None and "rpm_limiter_no_limit" in self.__fields_set__:
            _dict['rpmLimiterNoLimit'] = None

        # set to None if rpm_limiter_power_limit (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_power_limit is None and "rpm_limiter_power_limit" in self.__fields_set__:
            _dict['rpmLimiterPowerLimit'] = None

        # set to None if rpm_limiter_defrost (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_defrost is None and "rpm_limiter_defrost" in self.__fields_set__:
            _dict['rpmLimiterDefrost'] = None

        # set to None if rpm_limiter_silent_hours (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_silent_hours is None and "rpm_limiter_silent_hours" in self.__fields_set__:
            _dict['rpmLimiterSilentHours'] = None

        # set to None if rpm_limiter_hp_control (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_hp_control is None and "rpm_limiter_hp_control" in self.__fields_set__:
            _dict['rpmLimiterHPControl'] = None

        # set to None if rpm_limiter_pressure (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_pressure is None and "rpm_limiter_pressure" in self.__fields_set__:
            _dict['rpmLimiterPressure'] = None

        # set to None if rpm_limiter_water_out (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_water_out is None and "rpm_limiter_water_out" in self.__fields_set__:
            _dict['rpmLimiterWaterOut'] = None

        # set to None if rpm_limiter_envelope (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_envelope is None and "rpm_limiter_envelope" in self.__fields_set__:
            _dict['rpmLimiterEnvelope'] = None

        # set to None if rpm_limiter_house_in (nullable) is None
        # and __fields_set__ contains the field
        if self.rpm_limiter_house_in is None and "rpm_limiter_house_in" in self.__fields_set__:
            _dict['rpmLimiterHouseIn'] = None

        # set to None if p_compressor_in_average (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_in_average is None and "p_compressor_in_average" in self.__fields_set__:
            _dict['pCompressorInAverage'] = None

        # set to None if p_compressor_in_min (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_in_min is None and "p_compressor_in_min" in self.__fields_set__:
            _dict['pCompressorInMin'] = None

        # set to None if p_compressor_in_max (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_in_max is None and "p_compressor_in_max" in self.__fields_set__:
            _dict['pCompressorInMax'] = None

        # set to None if p_compressor_out_average (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_out_average is None and "p_compressor_out_average" in self.__fields_set__:
            _dict['pCompressorOutAverage'] = None

        # set to None if p_compressor_out_min (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_out_min is None and "p_compressor_out_min" in self.__fields_set__:
            _dict['pCompressorOutMin'] = None

        # set to None if p_compressor_out_max (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_out_max is None and "p_compressor_out_max" in self.__fields_set__:
            _dict['pCompressorOutMax'] = None

        # set to None if p_compressor_in_target_average (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_in_target_average is None and "p_compressor_in_target_average" in self.__fields_set__:
            _dict['pCompressorInTargetAverage'] = None

        # set to None if p_compressor_in_target_min (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_in_target_min is None and "p_compressor_in_target_min" in self.__fields_set__:
            _dict['pCompressorInTargetMin'] = None

        # set to None if p_compressor_in_target_max (nullable) is None
        # and __fields_set__ contains the field
        if self.p_compressor_in_target_max is None and "p_compressor_in_target_max" in self.__fields_set__:
            _dict['pCompressorInTargetMax'] = None

        # set to None if t_inverter_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t_inverter_average is None and "t_inverter_average" in self.__fields_set__:
            _dict['tInverterAverage'] = None

        # set to None if t_inverter_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t_inverter_min is None and "t_inverter_min" in self.__fields_set__:
            _dict['tInverterMin'] = None

        # set to None if t_inverter_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t_inverter_max is None and "t_inverter_max" in self.__fields_set__:
            _dict['tInverterMax'] = None

        # set to None if t_compressor_in_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_in_average is None and "t_compressor_in_average" in self.__fields_set__:
            _dict['tCompressorInAverage'] = None

        # set to None if t_compressor_in_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_in_min is None and "t_compressor_in_min" in self.__fields_set__:
            _dict['tCompressorInMin'] = None

        # set to None if t_compressor_in_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_in_max is None and "t_compressor_in_max" in self.__fields_set__:
            _dict['tCompressorInMax'] = None

        # set to None if t_compressor_out_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_out_average is None and "t_compressor_out_average" in self.__fields_set__:
            _dict['tCompressorOutAverage'] = None

        # set to None if t_compressor_out_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_out_min is None and "t_compressor_out_min" in self.__fields_set__:
            _dict['tCompressorOutMin'] = None

        # set to None if t_compressor_out_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_out_max is None and "t_compressor_out_max" in self.__fields_set__:
            _dict['tCompressorOutMax'] = None

        # set to None if t_compressor_in_transient_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_in_transient_average is None and "t_compressor_in_transient_average" in self.__fields_set__:
            _dict['tCompressorInTransientAverage'] = None

        # set to None if t_compressor_in_transient_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_in_transient_min is None and "t_compressor_in_transient_min" in self.__fields_set__:
            _dict['tCompressorInTransientMin'] = None

        # set to None if t_compressor_in_transient_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_in_transient_max is None and "t_compressor_in_transient_max" in self.__fields_set__:
            _dict['tCompressorInTransientMax'] = None

        # set to None if t_compressor_out_transient_average (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_out_transient_average is None and "t_compressor_out_transient_average" in self.__fields_set__:
            _dict['tCompressorOutTransientAverage'] = None

        # set to None if t_compressor_out_transient_min (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_out_transient_min is None and "t_compressor_out_transient_min" in self.__fields_set__:
            _dict['tCompressorOutTransientMin'] = None

        # set to None if t_compressor_out_transient_max (nullable) is None
        # and __fields_set__ contains the field
        if self.t_compressor_out_transient_max is None and "t_compressor_out_transient_max" in self.__fields_set__:
            _dict['tCompressorOutTransientMax'] = None

        # set to None if delta_t_compressor_in_superheat_average (nullable) is None
        # and __fields_set__ contains the field
        if self.delta_t_compressor_in_superheat_average is None and "delta_t_compressor_in_superheat_average" in self.__fields_set__:
            _dict['deltaTCompressorInSuperheatAverage'] = None

        # set to None if delta_t_compressor_in_superheat_min (nullable) is None
        # and __fields_set__ contains the field
        if self.delta_t_compressor_in_superheat_min is None and "delta_t_compressor_in_superheat_min" in self.__fields_set__:
            _dict['deltaTCompressorInSuperheatMin'] = None

        # set to None if delta_t_compressor_in_superheat_max (nullable) is None
        # and __fields_set__ contains the field
        if self.delta_t_compressor_in_superheat_max is None and "delta_t_compressor_in_superheat_max" in self.__fields_set__:
            _dict['deltaTCompressorInSuperheatMax'] = None

        # set to None if compressor_power_low_accuracy_average (nullable) is None
        # and __fields_set__ contains the field
        if self.compressor_power_low_accuracy_average is None and "compressor_power_low_accuracy_average" in self.__fields_set__:
            _dict['compressorPowerLowAccuracyAverage'] = None

        # set to None if compressor_power_low_accuracy_min (nullable) is None
        # and __fields_set__ contains the field
        if self.compressor_power_low_accuracy_min is None and "compressor_power_low_accuracy_min" in self.__fields_set__:
            _dict['compressorPowerLowAccuracyMin'] = None

        # set to None if compressor_power_low_accuracy_max (nullable) is None
        # and __fields_set__ contains the field
        if self.compressor_power_low_accuracy_max is None and "compressor_power_low_accuracy_max" in self.__fields_set__:
            _dict['compressorPowerLowAccuracyMax'] = None

        # set to None if fan_average (nullable) is None
        # and __fields_set__ contains the field
        if self.fan_average is None and "fan_average" in self.__fields_set__:
            _dict['fanAverage'] = None

        # set to None if fan_min (nullable) is None
        # and __fields_set__ contains the field
        if self.fan_min is None and "fan_min" in self.__fields_set__:
            _dict['fanMin'] = None

        # set to None if fan_max (nullable) is None
        # and __fields_set__ contains the field
        if self.fan_max is None and "fan_max" in self.__fields_set__:
            _dict['fanMax'] = None

        # set to None if fan_power_average (nullable) is None
        # and __fields_set__ contains the field
        if self.fan_power_average is None and "fan_power_average" in self.__fields_set__:
            _dict['fanPowerAverage'] = None

        # set to None if fan_power_min (nullable) is None
        # and __fields_set__ contains the field
        if self.fan_power_min is None and "fan_power_min" in self.__fields_set__:
            _dict['fanPowerMin'] = None

        # set to None if fan_power_max (nullable) is None
        # and __fields_set__ contains the field
        if self.fan_power_max is None and "fan_power_max" in self.__fields_set__:
            _dict['fanPowerMax'] = None

        # set to None if cm_mass_power_in_average (nullable) is None
        # and __fields_set__ contains the field
        if self.cm_mass_power_in_average is None and "cm_mass_power_in_average" in self.__fields_set__:
            _dict['cmMassPowerInAverage'] = None

        # set to None if cm_mass_power_out_average (nullable) is None
        # and __fields_set__ contains the field
        if self.cm_mass_power_out_average is None and "cm_mass_power_out_average" in self.__fields_set__:
            _dict['cmMassPowerOutAverage'] = None

        # set to None if p_requested_average (nullable) is None
        # and __fields_set__ contains the field
        if self.p_requested_average is None and "p_requested_average" in self.__fields_set__:
            _dict['pRequestedAverage'] = None

        # set to None if p_requested_min (nullable) is None
        # and __fields_set__ contains the field
        if self.p_requested_min is None and "p_requested_min" in self.__fields_set__:
            _dict['pRequestedMin'] = None

        # set to None if p_requested_max (nullable) is None
        # and __fields_set__ contains the field
        if self.p_requested_max is None and "p_requested_max" in self.__fields_set__:
            _dict['pRequestedMax'] = None

        # set to None if power_error_integral_average (nullable) is None
        # and __fields_set__ contains the field
        if self.power_error_integral_average is None and "power_error_integral_average" in self.__fields_set__:
            _dict['powerErrorIntegralAverage'] = None

        # set to None if power_error_integral_min (nullable) is None
        # and __fields_set__ contains the field
        if self.power_error_integral_min is None and "power_error_integral_min" in self.__fields_set__:
            _dict['powerErrorIntegralMin'] = None

        # set to None if power_error_integral_max (nullable) is None
        # and __fields_set__ contains the field
        if self.power_error_integral_max is None and "power_error_integral_max" in self.__fields_set__:
            _dict['powerErrorIntegralMax'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> HeatPumpLogViewDto:
        """Create an instance of HeatPumpLogViewDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HeatPumpLogViewDto.parse_obj(obj)

        _obj = HeatPumpLogViewDto.parse_obj({
            "time_bucket": obj.get("timeBucket"),
            "interval": obj.get("interval"),
            "time_covered_in_interval": obj.get("timeCoveredInInterval"),
            "heat_pump_state_standby": obj.get("heatPumpStateStandby"),
            "heat_pump_state_heating": obj.get("heatPumpStateHeating"),
            "heat_pump_state_defrost_req_active": obj.get("heatPumpStateDefrostReqActive"),
            "heat_pump_state_defrost_open_valve": obj.get("heatPumpStateDefrostOpenValve"),
            "heat_pump_state_defrost_close_valve": obj.get("heatPumpStateDefrostCloseValve"),
            "heat_pump_state_defrost_drip": obj.get("heatPumpStateDefrostDrip"),
            "heat_pump_state_defrost_cooling": obj.get("heatPumpStateDefrostCooling"),
            "heat_pump_state_cooling": obj.get("heatPumpStateCooling"),
            "heat_pump_state_dhw": obj.get("heatPumpStateDHW"),
            "heat_pump_state_legionnaires_disease_prevention": obj.get("heatPumpStateLegionnairesDiseasePrevention"),
            "rpm_control_startup": obj.get("rpmControlStartup"),
            "rpm_control_running": obj.get("rpmControlRunning"),
            "rpm_control_running_abnormally": obj.get("rpmControlRunningAbnormally"),
            "rpm_control_shutdown": obj.get("rpmControlShutdown"),
            "control_bridge_status_water_pump": obj.get("controlBridgeStatusWaterPump"),
            "control_bridge_status_dhw_valve": obj.get("controlBridgeStatusDhwValve"),
            "control_bridge_status_gas_boiler": obj.get("controlBridgeStatusGasBoiler"),
            "control_bridge_status_electric_heater": obj.get("controlBridgeStatusElectricHeater"),
            "control_bridge_status_water_pump2": obj.get("controlBridgeStatusWaterPump2"),
            "dtc_none": obj.get("dtcNone"),
            "dtc_continue": obj.get("dtcContinue"),
            "dtc_compressor_off": obj.get("dtcCompressorOff"),
            "dtc_defrost_forbidden": obj.get("dtcDefrostForbidden"),
            "dtc_request_service": obj.get("dtcRequestService"),
            "dtc_use_heating_curve": obj.get("dtcUseHeatingCurve"),
            "dtc_dhw_forbidden": obj.get("dtcDhwForbidden"),
            "dtc_error": obj.get("dtcError"),
            "dtc_inactive": obj.get("dtcInactive"),
            "signal_strength_average": obj.get("signalStrengthAverage"),
            "signal_strength_min": obj.get("signalStrengthMin"),
            "signal_strength_max": obj.get("signalStrengthMax"),
            "t1_average": obj.get("t1Average"),
            "t1_min": obj.get("t1Min"),
            "t1_max": obj.get("t1Max"),
            "t2_average": obj.get("t2Average"),
            "t2_min": obj.get("t2Min"),
            "t2_max": obj.get("t2Max"),
            "t_spare_ntc_average": obj.get("tSpareNtcAverage"),
            "t_spare_ntc_min": obj.get("tSpareNtcMin"),
            "t_spare_ntc_max": obj.get("tSpareNtcMax"),
            "t_board_average": obj.get("tBoardAverage"),
            "t_board_min": obj.get("tBoardMin"),
            "t_board_max": obj.get("tBoardMax"),
            "t_air_in_average": obj.get("tAirInAverage"),
            "t_air_in_min": obj.get("tAirInMin"),
            "t_air_in_max": obj.get("tAirInMax"),
            "t_air_out_average": obj.get("tAirOutAverage"),
            "t_air_out_min": obj.get("tAirOutMin"),
            "t_air_out_max": obj.get("tAirOutMax"),
            "t_water_in_average": obj.get("tWaterInAverage"),
            "t_water_in_min": obj.get("tWaterInMin"),
            "t_water_in_max": obj.get("tWaterInMax"),
            "t_water_out_average": obj.get("tWaterOutAverage"),
            "t_water_out_min": obj.get("tWaterOutMin"),
            "t_water_out_max": obj.get("tWaterOutMax"),
            "t_water_house_in_average": obj.get("tWaterHouseInAverage"),
            "t_water_house_in_min": obj.get("tWaterHouseInMin"),
            "t_water_house_in_max": obj.get("tWaterHouseInMax"),
            "rpm_average": obj.get("rpmAverage"),
            "rpm_min": obj.get("rpmMin"),
            "rpm_max": obj.get("rpmMax"),
            "rpm_limiter_average": obj.get("rpmLimiterAverage"),
            "rpm_limiter_min": obj.get("rpmLimiterMin"),
            "rpm_limiter_max": obj.get("rpmLimiterMax"),
            "rpm_limiter_no_limit": obj.get("rpmLimiterNoLimit"),
            "rpm_limiter_power_limit": obj.get("rpmLimiterPowerLimit"),
            "rpm_limiter_defrost": obj.get("rpmLimiterDefrost"),
            "rpm_limiter_silent_hours": obj.get("rpmLimiterSilentHours"),
            "rpm_limiter_hp_control": obj.get("rpmLimiterHPControl"),
            "rpm_limiter_pressure": obj.get("rpmLimiterPressure"),
            "rpm_limiter_water_out": obj.get("rpmLimiterWaterOut"),
            "rpm_limiter_envelope": obj.get("rpmLimiterEnvelope"),
            "rpm_limiter_house_in": obj.get("rpmLimiterHouseIn"),
            "p_compressor_in_average": obj.get("pCompressorInAverage"),
            "p_compressor_in_min": obj.get("pCompressorInMin"),
            "p_compressor_in_max": obj.get("pCompressorInMax"),
            "p_compressor_out_average": obj.get("pCompressorOutAverage"),
            "p_compressor_out_min": obj.get("pCompressorOutMin"),
            "p_compressor_out_max": obj.get("pCompressorOutMax"),
            "p_compressor_in_target_average": obj.get("pCompressorInTargetAverage"),
            "p_compressor_in_target_min": obj.get("pCompressorInTargetMin"),
            "p_compressor_in_target_max": obj.get("pCompressorInTargetMax"),
            "t_inverter_average": obj.get("tInverterAverage"),
            "t_inverter_min": obj.get("tInverterMin"),
            "t_inverter_max": obj.get("tInverterMax"),
            "t_compressor_in_average": obj.get("tCompressorInAverage"),
            "t_compressor_in_min": obj.get("tCompressorInMin"),
            "t_compressor_in_max": obj.get("tCompressorInMax"),
            "t_compressor_out_average": obj.get("tCompressorOutAverage"),
            "t_compressor_out_min": obj.get("tCompressorOutMin"),
            "t_compressor_out_max": obj.get("tCompressorOutMax"),
            "t_compressor_in_transient_average": obj.get("tCompressorInTransientAverage"),
            "t_compressor_in_transient_min": obj.get("tCompressorInTransientMin"),
            "t_compressor_in_transient_max": obj.get("tCompressorInTransientMax"),
            "t_compressor_out_transient_average": obj.get("tCompressorOutTransientAverage"),
            "t_compressor_out_transient_min": obj.get("tCompressorOutTransientMin"),
            "t_compressor_out_transient_max": obj.get("tCompressorOutTransientMax"),
            "delta_t_compressor_in_superheat_average": obj.get("deltaTCompressorInSuperheatAverage"),
            "delta_t_compressor_in_superheat_min": obj.get("deltaTCompressorInSuperheatMin"),
            "delta_t_compressor_in_superheat_max": obj.get("deltaTCompressorInSuperheatMax"),
            "compressor_power_low_accuracy_average": obj.get("compressorPowerLowAccuracyAverage"),
            "compressor_power_low_accuracy_min": obj.get("compressorPowerLowAccuracyMin"),
            "compressor_power_low_accuracy_max": obj.get("compressorPowerLowAccuracyMax"),
            "fan_average": obj.get("fanAverage"),
            "fan_min": obj.get("fanMin"),
            "fan_max": obj.get("fanMax"),
            "fan_power_average": obj.get("fanPowerAverage"),
            "fan_power_min": obj.get("fanPowerMin"),
            "fan_power_max": obj.get("fanPowerMax"),
            "cm_mass_power_in_average": obj.get("cmMassPowerInAverage"),
            "cm_mass_power_out_average": obj.get("cmMassPowerOutAverage"),
            "p_requested_average": obj.get("pRequestedAverage"),
            "p_requested_min": obj.get("pRequestedMin"),
            "p_requested_max": obj.get("pRequestedMax"),
            "power_error_integral_average": obj.get("powerErrorIntegralAverage"),
            "power_error_integral_min": obj.get("powerErrorIntegralMin"),
            "power_error_integral_max": obj.get("powerErrorIntegralMax"),
            "thermostat_state_off": obj.get("thermostatStateOff"),
            "thermostat_state_on": obj.get("thermostatStateOn"),
            "t_room_average": obj.get("tRoomAverage"),
            "t_room_min": obj.get("tRoomMin"),
            "t_room_max": obj.get("tRoomMax"),
            "t_room_target_average": obj.get("tRoomTargetAverage"),
            "t_room_target_min": obj.get("tRoomTargetMin"),
            "t_room_target_max": obj.get("tRoomTargetMax"),
            "t_thermostat_setpoint_average": obj.get("tThermostatSetpointAverage"),
            "t_thermostat_setpoint_min": obj.get("tThermostatSetpointMin"),
            "t_thermostat_setpoint_max": obj.get("tThermostatSetpointMax"),
            "ot_boiler_feed_temperature_average": obj.get("otBoilerFeedTemperatureAverage"),
            "ot_boiler_feed_temperature_min": obj.get("otBoilerFeedTemperatureMin"),
            "ot_boiler_feed_temperature_max": obj.get("otBoilerFeedTemperatureMax"),
            "ot_boiler_return_temperature_average": obj.get("otBoilerReturnTemperatureAverage"),
            "ot_boiler_return_temperature_min": obj.get("otBoilerReturnTemperatureMin"),
            "ot_boiler_return_temperature_max": obj.get("otBoilerReturnTemperatureMax")
        })
        return _obj


